//#include <SimpleExmpl/SimpleExmpl_Modules.h>

#include <emC/Base/Exception_emC.h>
#include <emC/Ipc/SocketComm_Ipc_emC.h>
#include <emC/Ipc/DatagramHead_Ipc_emC.h>
#include "genSrc/Test_WaveMngAvg3data2.h"
#include <stdio.h>
#include <stdlib.h>
//The C file describes only the behavior of this module. No more.


Test_WaveMngAvg3data2_s filter;


struct MainData_T {
  float x;
  float xfq;
  struct ScopeData_T {
    DatagramHead_Ipc_emC_s head;    // it should be start on a even address dividable by 4.
    DatagramItem_Ipc_emC_s item1;
    int32BigEndian timesh;
    floatBigEndian time_ms;
    floatBigEndian x1;
    floatBigEndian x2; 
    floatBigEndian y11; 
    floatBigEndian y12; 
    floatBigEndian y21; 
    floatBigEndian y22; 
    floatBigEndian y31; 
    floatBigEndian y32; 
    floatBigEndian yg; 
    floatBigEndian yph; 
    floatBigEndian yph2; 
    floatBigEndian fd; 
    floatBigEndian xfq; 
    floatBigEndian fq1;
  } scopeData;
  
  struct ScopeRxData_T {
    DatagramHead_Ipc_emC_s head;    // it should be start on a even address dividable by 4.
    DatagramItem_Ipc_emC_s item1;
    int32BigEndian anyValue[3];
    int32BigEndian reserve[16];
  } scopeRxData;

} data = {0};

SocketComm_Ipc_emC_s scope;
//OS_SOCKADDR ownSenderAddr;
//OS_SOCKADDR scopeAddr;
//OS_DatagramSocket scope;

static int stop () { return 0; }

//Test_WaveMngAvg3data2_s* pdata = (Test_WaveMngAvg3data2_s*)malloc(sizeof(OrthBandpass16_Ctrl_emC_s)); 

void main(void){
  float Tstep = 0.000050f;
  ctor_Test_WaveMngAvg3data2(&filter, 400.0f, 1.0f, Tstep, 0.1f);
  //
  bool bInitOk = true;
  int ctAbortInit = 10;
  do { 
    bool bInitOkPart;
    bInitOkPart = init_Test_WaveMngAvg3data2(&filter);
    bInitOk &= bInitOkPart;
  } while(!bInitOk && --ctAbortInit >=0);

  int nstepEnd = 30000;
  int step = 0;
  float angle = 0;
  float angle3 = 0;
  float dangle3 = 3* PI_float_emC / 200.0f;  // 400 steps in 2*pi
  //int scopeOk = 0;
  //scopeOk = os_createDatagramSocket(&scope);
  ctor_SocketComm_Ipc_emC(&scope, 0x7f000001, 0xaef0 );  //127.0.0.1:44784 own address
  bool scopeOk = open_SocketComm_Ipc_emC(&scope, &data.scopeRxData, sizeof(data.scopeRxData), 50000);
  if(scopeOk) {
    //set_OS_SOCKADDR(&ownSenderAddr, 0x7f000001, 0xaef0);  
    setAddrDst_SocketComm_Ipc_emC(&scope, 0x7f000001, 0xaef1);      //127.0.0.1:44785 destination address
    //scopeOk = os_bind(scope.socket, &ownSenderAddr);
    //printf("bind %d", scopeOk);
    setInt16BigEndian(&data.scopeData.head.nrofBytes, sizeof(data.scopeData));
    setInt16BigEndian(&data.scopeData.head.cmd, (int16)0xaeea);
    setInt16BigEndian(&data.scopeData.item1.nrofBytes, sizeof(data.scopeData)- sizeof(data.scopeData.head));
    setInt16BigEndian(&data.scopeData.item1.cmd, (int16)0xaeeb);
  }
  FILE* fData = fopen("..\\..\\..\\src\\ExmplExmplWaveAvg\\data\\fq1.csv", "wb");
  if(fData !=null) {
    fprintf(fData, "timesh; time_ms; x; y11; y12; y21; y22; y31; y32; x1; x2");
  }
  data.xfq = 50.0f;
  
  while(++step < nstepEnd){
    upd_Test_WaveMngAvg3data2(&filter);
    float dangle = data.xfq * 2*PI_float_emC * Tstep;  // 400 steps in 2*pi
  
    data.x = sinf(angle += dangle) + 0.05f *cosf(angle3 += 3* dangle);
    if(step >= 7000 && step <=8500) {      // frequency drift from 50.0 Hz to 49.8 Hz
      data.xfq += 0.2f /500;                    // 0.2 Hz in 500 steps
    }
    else if(step >= 10000 && step <=13000) {      // frequency drift from 50.0 Hz to 49.8 Hz
      data.xfq -= 0.2f /500;                    // 0.2 Hz in 500 steps
    }
    else if(step >= 16900 && step <=20000) {      // frequency drift from 50.0 Hz to 49.8 Hz
      if(data.x > 0.9f) {
        data.x += 0.5f * (data.x - 0.9f); 
      }
    }
    if(angle >= PI_float_emC) { angle -= 2*PI_float_emC; }
    if(step == 9000){      
      step +=0;
    }
    step_Test_WaveMngAvg3data2(&filter, data.x, 0.0);
    if(scope.openOk) {
//      if(hasRxTelg(&scope)) {
//        int32 seqnr = getInt32BigEndian(&data.scopeRxData.seqnr);
//        setSeqnrRx(&scope, (int16)seqnr);        // inform the telegram synchronization about received seqnr.
//      }
      // ------------------------------------------ first counts back to clear Data
      setInt32BigEndian(&data.scopeData.head.seqnr, step);
      setInt32BigEndian(&data.scopeData.timesh, step<4 ? -step : step);
      setFloatBigEndian(&data.scopeData.time_ms, step*0.00005f);
      setFloatBigEndian(&data.scopeData.x1, data.x);
      setFloatBigEndian(&data.scopeData.y11, filter.dout.y11);
      setFloatBigEndian(&data.scopeData.y12, filter.dout.y12);
      setFloatBigEndian(&data.scopeData.y21, filter.dout.y21);
      setFloatBigEndian(&data.scopeData.y22, filter.dout.y22);
      setFloatBigEndian(&data.scopeData.y31, filter.dout.y31);
      setFloatBigEndian(&data.scopeData.y32, filter.dout.y32);
      setFloatBigEndian(&data.scopeData.fd,  filter.dout.fd);
      setFloatBigEndian(&data.scopeData.xfq,  data.xfq);
      setFloatBigEndian(&data.scopeData.fq1,  1.0f / ((400.0f - filter.dout.fd) * 0.00005f));
      scopeOk = sendToDst_SocketComm_Ipc_emC (&scope, &data.scopeData, sizeof(data.scopeData), (int16)step, 100);

      stop();
    }
    if(fData !=null) {
      fprintf(fData,"\n%d; %1.5f; %1.4f; %1.4f; %1.4f; %1.4f; %1.4f; %1.4f; %1.4f; %1.4f;"
      , step, step*0.00005f
      , data.x
      , data.x
      , filter.dout.y11
      , filter.dout.y12
      , filter.dout.y21
      , filter.dout.y22
      , filter.dout.y31
      , filter.dout.y32
      );
    }
  }
  if(fData !=null) {
    fprintf(fData, "\n");
    fclose(fData);
  }
  close_SocketComm_Ipc_emC(&scope);
  printf("end\n");
}



void uncatched_Exception_emC ( Exception_emC* ythis, ThreadContext_emC_s* _thCxt){
  printf("ERROR");
}

void errorSystem_emC_  (  int errorCode, const char* description, int value1, int value2, char const* file, int line){
  printf("ERROR");
}
