#include <genSrc/MyExample.h>

#include <stdio.h>

/**Use static allocated data, but her not initialized (to enforce a problem)
 */
MyExample_s myExample;  // = {0] will be better


float exampleInputs[10][2] =
{ { 1.0f,   1.0f } 
, { 0.9f,   1.0f }
, { 0.8f,   1.0f }
, { 0.707f, 1.0f }
, { 0.707f, 0.9f }
, { 0.707f, 0.8f }
, { 0.707f, 0.707f }
, { 0.6f,   0.707f }
, { 0.5f,   0.707f }
, { 0.1f,   0.707f }
};

int main() {

  ctor_MyExample(&myExample);
  //
  int ctInitAbort = 10;
  bool bInitOk;
  do {     //============================ initialization loop
    bInitOk = true;                    // expect all is initilized
    if(!init_MyExample(&myExample)) {
      bInitOk = false;                 // if one module fails, repeat
    }                                  // (we have here only ones)
  } while(!bInitOk && --ctInitAbort >0);
  //
  if(!bInitOk) {
    printf("System cannot run, internal error, intialization fails\n");
    return 10;
  } else {  //=========================== Heureka, run mode reached
    int ix;
    int ixMax = ARRAYLEN(exampleInputs);
    for(ix = 0; ix < ixMax; ++ix) {         // usual a device runs cyclically, here only for each test data 
      float a = exampleInputs[ix][0];       // this is here test organization component test (very simple)
      float b = exampleInputs[ix][1];
      step_MyExample(&myExample, a, b);     // THIS FUNCTIONALITY IS DESIGNED IN THE GRAPHIC
      //  
      float magn = myExample.fb1.magn;      // access internal value of core components for debug possible.
      //                                    // also access of known graphical module elements possible
      float y = myExample.dout.y;           // access the result on the output pin of the graphic module.
      printf("a=%2.3f b=%2.3f magn=%2.3f  y=%2.3f\n", a, b, magn, y);
    }
  } 
  printf("all is done, I can die\n");
  return 0;
}
